SystemOrganization addCategory: #'Pier-Setup'!

!GRPackage class methodsFor: '*pier-setup' stamp: 'lr 2/26/2010 23:09'!
pierSetup
	^ self new
		name: 'Pier-Setup';
		description: 'A default setup with several templates to get started with Pier.';
		addDependency: 'Pier-Model';
		addDependency: 'Pier-Seaside';
		addDependency: 'Pier-Security';
		addDependency: 'Pier-Blog';
		addDependency: 'Pier-Book';
		addDependency: 'Pier-Documents';
		addDependency: 'Pier-EditorEnh';
		addDependency: 'Pier-LinkChecker';
		addDependency: 'Pier-Google';
		url: #pierAddonsUrl;
		yourself! !

Object subclass: #PRDistribution
	instanceVariableNames: 'blog contentsWidget environmentPage metaEnvironmentPage breadcrumbWidget commandsPage googleAnalyticsWidget siteTitlePage sitemapPage stylesheetFile systemManagementPage viewsPage menuWidget loginCommandWidget mainEnvironmentPage childrenWidget postTickerWidget rootPage kernel syntaxPage aboutPage blogArchiveWidget blogEnvironmentPage poweredByPage searchWidget headerPage footerPage shortcutsPage loggedInUserPage designChooserWidget fileSettingsWidget documentWidget systemPage componentsPage templatesPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

PRDistribution subclass: #PRBookDistribution
	instanceVariableNames: 'book tableOfContents introduction tableOfFigures section index notesComponent bookStylesheetFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PRBookDistribution class methodsFor: 'accessing' stamp: 'tg 11/5/2009 14:31'!
title
	^ 'Book'! !

!PRBookDistribution methodsFor: 'structures' stamp: 'tg 11/8/2009 22:49'!
book
	^ book ifNil: [
		book := (BOBook named: 'book')
			contents: 'This is a book';
			yourself
	]! !

!PRBookDistribution methodsFor: 'structures' stamp: 'lr 6/17/2010 09:42'!
bookStylesheetFile
	bookStylesheetFile isNil
		ifFalse: [ ^ bookStylesheetFile ].
	bookStylesheetFile := (PRFile named: 'bookCss')
		filename: 'bookstyle.css';
		mimetype: 'text/css';
		contents: 
'/* ANNOTATIONS */
p.blockquote { padding: 0.8em; margin-left: 2em; margin-bottom: 1em; }
p.todo { color: red; }
p.todo:before { color: red; content: "TODO"; }
p.note { color: blue; border-top: 1px solid #bbb; border-bottom: 1px solid #bbb; padding: 0.8em; padding-left: 0; margin-bottom: 1em}
p.note:before { color: blue; content: "Note"; }
p.todo, p.note {  font-family: "Helvetica Neue", Helvetica, Arial, sans-serif; position: relative; }
p.todo:before, p.note:before {left: -20%; width: 18%; text-align: right; position: absolute; }
 
/* === head === */
.head {
	height: 96px;
	text-align: left;
	position: relative;
	background-repeat: repeat-x;
	background-image: url(header.png);
}
.head h1 {
	float: left;
	margin: 0 20px;
	font-size: 20px;
	line-height: 60px;
}
.head h1 a { color: #fff; }
.head .donate { float: right; margin-right: 20px; }
.head .donate form { line-height: 60px; }
.head .donate form input { vertical-align: middle; }
.head .search { float: right; margin-right: 20px; line-height: 60px; }
.head .search input { width: 150px; vertical-align: middle; }
 
/* BODY */
.wrap {
	text-align: left;
	padding-bottom: 2ex;
	background-color: #fff;
}
.body {
	margin: auto 10%;
	text-align: left;
}
 
/* MAIN */
.main {
	float: left;
	width: 62.5%;
	text-align: left;
	position: relative;
}
.main h1.capt span {
	left: -20%;
	width: 18%;
	text-align: right;
	position: absolute;
}
.main div.figure {
	position: relative;
	margin-bottom: 1.6em;
}
.main div.figure img {
	float: none;
	margin: 0 auto;
	display: block;
	max-width: 100%;
	text-align: center;
}
.main div.figure label {
	display: block;
	text-align: center;
	font-weight: normal;
}
.main div.figure label span {font-weight: italic;}

.main .table-of-contents { font-family: "Helvetica Neue", Helvetica, Arial, sans-serif; }
.main .table-of-contents dl { position: relative; }
.main .table-of-contents dt { width: 30px; position: absolute; }
.main .table-of-contents dd  { padding-left: 40px; }
.main .table-of-contents a.part { font-weight: bold; }
.main .table-of-contents a.section { padding-left: 2em; }
.main .table-of-contents a.subsection { padding-left: 4em; }
 
.main .table-of-figures dl { position: relative; }
.main .table-of-figures dt { width: 30px; position: absolute; text-align: right; }
.main .table-of-figures dd { padding-left: 40px; }
 
.main .keyword-index dl { position: relative; }
.main .keyword-index dt { width: 200px; position: absolute; }
.main .keyword-index dd { padding-left: 220px; }
 
/* --- side --- */
.side {
	font-family: "Helvetica Neue", Helvetica, Arial, sans-serif; 
	width: 25%;
	float: right;
	text-align: left;
	position: relative;
}
.side dl dt {
	left: -50%;
	width: 45%;
	text-align: right;
	position: absolute;
}
.side p, .side li, .side dd, .side dt { text-align: left; }
 
/* === footers === */
.notes, .admin, .foot { 
	padding: 20px;
	text-align: left;
	background-repeat: repeat-x;
	background-image: url(footer.png);
}
.hidden {
	width: 0px;
	height: 0px;
	left: -1000px;
	position: absolute;
 
}
 
/* --- notes --- */
.notes { font-family: "Helvetica Neue", Helvetica, Arial, sans-serif; }
.notes h1 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
.notes .listing .note { margin-bottom: 1em; }
.notes .listing .note .meta { border-bottom: 1px solid #ddd; margin-bottom: 1em; }
.notes .listing .note .meta .author { font-weight: normal; }
.notes .listing .note .meta .publication { font-size: 80%; }
.notes .listing .note .meta .commands { float: right; }
.notes .listing .note .body { margin: 0; font: 1em ''andale mono'', ''lucida console'', monospace; line-height: 1.5; }
.notes .listing .note .body p { margin: 0; }
.notes .addnote th { width: 120px; }
.notes .addnote textarea { height: 100px; width: 100%; }
.notes .addnote .buttons { margin-left: 130px; }
.notes .addnote .buttons input { margin-right: 1em; }
 
/* --- admin --- */
.admin { font-size: .8em; line-height: 1.875em; color: #555; }
.admin .tool { width: 25%; float: left; }
.admin .tool ul { margin: 0; padding: 0; list-style: none; }
.admin .tool li li { margin-left: 1em; }
.admin .tool li span.button { float: left; width: 1em; }
.admin .tool .active { font-weight: bold; }
 
/* --- foot --- */
.foot { font-size: 0.7em; line-height: 1.765em; padding-bottom: 0;  font-family: "Helvetica Neue", Helvetica, Arial, sans-serif; }
.foot p { text-align: center; }
 
/* === pages === */
body.book h1.capt { display: none; }
body.book img { margin: 0; max-width: 515px; }

/*DEFAULT*/
p, li, dd, dt { text-align: left; }
body { font-size: 90%; background-color: #eee; font-family: Georgia, "Lucida Bright", "Times New Roman", serif;}
table, tr, td, th { margin: 0; border: 0; padding-left: 0; font-weight: bold; }
table { margin-bottom: 1.6em; }
h1, h2, h3, h4, h5, h6 { font-family: "Helvetica Neue", Helvetica, Arial, sans-serif; }
h1 a, h2 a, h3 a, h4 a, h5 a, h5 a, h6 a { color: #222; text-decoration: none; outline: none; }
h1 a:hover, h2 a:hover, h3 a:hover, h4 a:hover, h5 a:hover, h5 a:hover, h6 a:hover { color: #222; }
pre { padding: 5px; background-color: #eee; -moz-border-radius: 5px; -webkit-border-radius: 5px; }
code, tt { padding: 2px; background-color: #eee; -moz-border-radius: 3px; -webkit-border-radius: 3px; }
h1 { font-size: 2em; line-height: 1; margin-bottom: 0.75em; }
h2 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
h3 { font-size: 1.2em; line-height: 1.25; margin-bottom: 1.25em; }
h4 { font-size: 1em; line-height: 1; margin-bottom: 1.5em; }
h5 { font-size: 1em; line-height: 1; }
ins { background: #E6EFC2; color: #264409; }
del { background: #FBE3E4; color: #8a1f11; }
label { font-weight:normal; }

/* PIER */
.errors, .broken { color: red; font-weight: bold;}
.error, .notice, .success { border: none; }
.protected { color: #aaa; }
a {color: #ff6633;}
a:hover {
	color: white;
	background: #ff6633; }
a:hover.nobackground {background: white;}
a.view, a.command {color: gray;}
a.external { background: url(external.png) right center no-repeat; padding-right: 14px; }
a {text-decoration: none;}
.right {text-align: right;}
.left {text-align: left;}
.center {text-align: center;}
tr th {background: #eee; font-weight: normal;}
tr.group th {background: white; font-size: 1em; font-weight: bold; margin-top: 1.5em; }
td.required:after {color: #ff6633; content: "*"; margin-left: 0.5em;}

'.	
	^bookStylesheetFile
! !

!PRBookDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:18'!
environmentPage
	^ environmentPage ifNil: [
		environmentPage := (PRPage named: 'environment')
		title: '_Environment';
		contents: 
'{{{<div class="wrap">
  <div class="body">
    <div class="main">
      <h1 class="capt"><span>}}}*>value:structure|display=number*{{{</span>}}}*value:structure|link*{{{</h1>
      }}}+/system/components/contents+{{{
    </div>
    <div class="side">}}}
      *>value:book.parent*
      *>value:book.navigation*{{{
    </div>
    <div class="clear"></div>
  </div>
</div>}}}
+/system/components/notes+{{{
<div class="foot">}}}+/system/components/footer+{{{</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]
! !

!PRBookDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:13'!
index
	^ index ifNil: [ index := (BOPortion named: 'index')
		type: #chapter;
		title: 'Keyword index';
		contents: '{{{<div class="keyword-index">}}}*value:book.index|target=/book*{{{</div>}}}';
		write: false using: BOPortion descriptionNumberedTitle;
		yourself ]
! !

!PRBookDistribution methodsFor: 'structures' stamp: 'tg 2/2/2010 15:19'!
introduction
	^ introduction ifNil: [ introduction := (BOPortion named: 'introduction')
		type: #chapter;
		contents: 'A book is formed by chapters. This is a chapter.
You can define references like: +ref:section+.

You can define +index:keywords!!keywords+ keywords that appear automatically in the keyword index.';
		yourself ]
! !

!PRBookDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
mainEnvironmentPage
"Removed:
		<div class=postticker column prepend-6 span-6 last>
			<h2>What''s new</h2>
			+/system/components/postticker+
			+/system/components/sidebar+
		</div>
"

	^ mainEnvironmentPage ifNil: [
		mainEnvironmentPage := (PRPage named: 'mainenvironment')
		title: '_Main Environment';
		contents: 
'{{{<div class="container">}}}
	+/system/components/header+{{{
	<div class="column span-24 last mainbody">
		<h1 class="heading">}}}*value:structure*{{{</h1>
		<div class="contents column span-12">}}}+/system/components/contents+{{{</div>
	</div>
	}}}+/system/components/footer+{{{
</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]! !

!PRBookDistribution methodsFor: 'structures' stamp: 'razavi@acm.org 1/12/2010 14:08'!
menuPage
	^ menuWidget ifNil: 
		[ menuWidget := (PRPage named: 'menu')
			contents:
'- *Home>/*
- *Book>/book*
- *About>/about*';
			yourself ]! !

!PRBookDistribution methodsFor: 'structures' stamp: 'tg 11/15/2009 03:06'!
notesComponent
	^ notesComponent ifNil: [notesComponent := 
		(PRComponent named: 'notes')
		title: 'Notes';
		componentClass: BONoteWidget;
		yourself
	]! !

!PRBookDistribution methodsFor: 'creation' stamp: 'razaviacmorg 7/3/2011 11:08'!
root
	self rootPage
		addChild: (self aboutPage
				addChild: self syntaxPage;
				yourself);
		addChild: (self book
				addChild: self tableOfContents;
				addChild: self tableOfFigures;
				addChild: (self introduction
					addChild: self section;
					yourself);
				addChild: self index;
				yourself);
		addChild: (self systemPage
			addChild: (self componentsPage
				addChild: self headerPage;
				addChild: self siteTitlePage;
				addChild: self footerPage;
				addChild: self menuPage;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self bookStylesheetFile;
				"addChild: self postTickerWidget;
				addChild: self blogArchiveWidget;"
				addChild: self searchWidget;
				addChild: self poweredPage;
				addChild: self loggedInUserPage;
				addChild: self designChooserWidget;
				addChild: self notesComponent;
"				addChild: self documentWidget;
"				yourself);
			addChild: self systemManagementPage;
			addChild: (self templatesPage
				addChild: self environmentPage;
				"addChild: self blogEnvironmentPage;"
				addChild: self mainEnvironmentPage;
				addChild: self metaEnvironmentPage;
				yourself
			);
			yourself
		).
	self rootPage localEnvironment: self mainEnvironmentPage.
	"self blog localEnvironment: self blogEnvironmentPage."
	self environmentPage localEnvironment: self metaEnvironmentPage.
	"self mainEnvironmentPage localEnvironment: self metaEnvironmentPage."
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self systemManagementPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	
"Specific to the book"
	self book localEnvironment: self environmentPage.
	self book localStyleSheet: self bookStylesheetFile.
	
	self rootPage enumerator
		with;
		all;
		do: 
			[ :each | 
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self systemPage.
	self makePrivate: self environmentPage.
	"self makePrivate: self blogEnvironmentPage."
	self makePrivate: self mainEnvironmentPage.
	self makePrivate: self metaEnvironmentPage.
	self makePrivate: self sitemapPage.
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	self makePrivate: self loggedInUserPage.
	"pier-sprint-eindhoven -http://forum.world.st/huge-security-problem-with-pier-td3241518.html".	
	self makePrivate: self designChooserWidget.
	^ self rootPage
! !

!PRBookDistribution methodsFor: 'structures' stamp: 'tg 2/2/2010 15:19'!
section
	^ section ifNil: [ section := (BOPortion named: 'section')
		type: #section;
		contents: 'This is a section.
@@todo this is a todo annotation.

@@note this is a note annotation.
';
		yourself ]
! !

!PRBookDistribution methodsFor: 'structures' stamp: 'razavi@acm.org 2/20/2010 22:38'!
stylesheetFile
	^super stylesheetFile
! !

!PRBookDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
tableOfContents
	^ tableOfContents ifNil: [ tableOfContents := (BOPortion named: 'table-of-contents')
		title: 'Table of contents';
		type: #chapter;
		contents: '{{{<div class="table-of-contents">}}}*value:book.contents|target=/book*{{{</div>}}}';
		write: false using: BOPortion descriptionNumberedTitle;
		yourself ]
! !

!PRBookDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
tableOfFigures
	^ tableOfFigures ifNil: [ tableOfFigures := (BOPortion named: 'table-of-figures')
		title: 'Table of figures';
		type: #chapter;
		contents: '{{{<div class="table-of-figures">}}}*value:book.figures|target=/book*{{{</div>}}}';
		write: false using: BOPortion descriptionNumberedTitle;
		yourself ]
! !

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 7/26/2010 19:04'!
register
	^ self new register! !

!PRDistribution class methodsFor: 'accessing' stamp: 'tg 2/18/2009 23:30'!
title
	"override this method to name the design"
	^'Default'! !

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 4/9/2010 14:28'!
workspaceText

	^
'"----------PIER-----------
Pier is already running at:
http://localhost:8080/pier

The Seaside server administration interface can be reached at: 
http://localhost:8080/config

The default username/password for Pier is admin/pier.
The default username/password for Seaside admin/seaside.

For more information about Pier check:
http://www.piercms.com
-------------------------"

"Web server management"
WAKomEncoded startOn: 8080.
WAKomEncoded stop.

"Memory cleanup"
WARegistry clearAllHandlers.
MCFileBasedRepository flushAllCaches.
Smalltalk garbageCollect.

"In memory persistency (default)"
PRKernel instances anyOne persistency: PRHistoryPersistency new.

"Image persistency (save up to 3 images and in 30 mins after a change)"
PRKernel instances anyOne persistency: (PRImagePersistency new 
											duration: 30 minutes;
											maxImages: 3).
			
"Reset all Pier settings to the original ones"
PRDistribution new register.

"Useful shortcuts"
PRKernel instances anyOne root.'! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 1/11/2010 21:13'!
aboutPage
	^ aboutPage ifNil: [
		aboutPage := (PRPage named: 'about')
					title: 'About Pier';
					contents:
'*Pier>http://www.piercms.com* is a content management system that aims at allowing users to manage their content from the browser.

The central concept in Pier is the one of Structure. For example, the current page is a structure. The */blog* is also a structure, but it is slightly different than a page. A file is also a structure.

Commands can be executed on a Structure. For example, a Structure can be edited. In the current setup you can edit this site after logging in (the commands appear in the footer). Once in edit mode, you can use the *syntax*. To make life easier, Pier also offers access to these commands via *shortcuts>http://www.piercms.com/doc/shortcuts*.

Any Structure can be Viewed. The default View is the one that renders the structure for normal usage. Another example, is the Browse View which offers a file system like view on the Pier structures.

Any Structure has an environment which defines the template. For example, the environment of this page is */system/templates* (you have to be logged in to see it). To set the environment to be a different page use the Settings command. To edit the environment use the Edit Design command.

A Structure can contain Widgets. For example, the environment of this page contains a menu widget on top, and a widget that enumerates the children of the current sturcture to the right.

More about Pier can be found at: *http://www.piercms.com*.'
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:15'!
blog
	^ blog ifNil: [
		blog := (PBBlog named: 'blog')
		addChild: (
			(PBPost named: 'downtobusiness')
			title: 'Down to business';
			contents: 'I like blogging, so here is my second post.';
			publication: TimeStamp now;
			addChild: ((PBComment named: '1')
				contents: 'We are glad to see that you get serious about blogging. Btw, this is a comment.';
				author: 'The Pier Team';
				website: 'http://www.piercms.com';
				yourself
				);
			yourself
		);
		addChild: (
			(PBPost named: 'hello')
			title: 'Hello';
			contents: 'Hi!! This is my first post.';
			publication: TimeStamp today;
			yourself
		);
		yourself
	].
! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:00'!
blogArchiveWidget
	^ blogArchiveWidget ifNil: [
		blogArchiveWidget := (PRComponent named: 'blogarchive')
		title: 'Blog Archive';
		componentClass: PBPostArchive;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:19'!
blogEnvironmentPage
	^ blogEnvironmentPage ifNil: [
		blogEnvironmentPage := (PRPage named: 'blogenvironment')
		title: '_Blog Environment';
		contents: 
'{{{<div class="container">
	}}}+/system/components/header+{{{
	<div class="column span-24 last mainbody">
		<h1 class="heading">}}}*>value:structure|level=2*{{{</h1>
		<h1>}}}*>value:structure|level=0|lower=3*{{{</h1>
		<div class="column span-12 contents">
			}}}+/system/components/contents+{{{
		</div>
		<div class="column span-6 prepend-6 last sidebar">
			<h2>Archive</h2>
			}}}+/system/components/blogarchive+{{{
		</div>
	</div>
	}}}+/system/components/footer+{{{
</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:24'!
breadcrumbWidget
	^ breadcrumbWidget ifNil: [breadcrumbWidget := (PRComponent named: 'breadcrumb')
		componentClass: PRBreadcrumbWidget;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:25'!
childrenWidget
	^ childrenWidget ifNil: [childrenWidget := (PRComponent named: 'children')
		componentClass: PRChildrenWidget;
		write: 2
			using: PRChildrenWidget descriptionLevel;
		write: true
			using: PRChildrenWidget descriptionExpand;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:01'!
commandsPage
	^ commandsPage ifNil: [
		commandsPage := (PRPage named: 'commands') 
		addChild: ((PRComponent named: 'widget') componentClass: PRCommandsWidget; yourself);
		contents: 'Commands: +widget+';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
componentsPage
	^ componentsPage ifNil: [
		componentsPage := (PRPage named: 'components')
		contents: '*value:children|link*';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/5/2009 00:01'!
contentsWidget
	^ contentsWidget ifNil: [
		contentsWidget := (PRComponent named: 'contents')
		componentClass: PRContentsWidget;
		write: '' using: PRContentsWidget descriptionHeading;
		yourself
	].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/18/2009 23:39'!
designChooserWidget
	^ designChooserWidget ifNil: [designChooserWidget := (PRComponent named: 'designchooser')
		componentClass: PRDesignChooserWidget;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'onierstrasz 4/17/2009 11:44'!
documentWidget
	^ documentWidget ifNil: [
		documentWidget := (PRComponent named: 'sidebar')
		title: 'Sidebar Document';
		componentClass: PRDocumentWidget;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:19'!
environmentPage
	^ environmentPage ifNil: [
		environmentPage := (PRPage named: 'environment')
		title: '_Environment';
		contents: 
'{{{<div class="container">
	}}}+/system/components/header+{{{
	<div class="column span-24 last mainbody">
		<h1 class="heading">}}}*>value:structure|level=2*{{{</h1>
		<h1>}}}*>value:structure|level=0|lower=3*{{{</h1>
		<div class="column span-12 contents">
			}}}+/system/components/contents+{{{
		</div>
		<div class="column span-6 prepend-6 last sidebar">
			<h2>Navigation</h2>
			}}}+/system/components/children+{{{
		</div>
	</div>
	}}}+/system/components/footer+{{{
</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/2/2010 17:52'!
footerPage
	^ footerPage ifNil: [
		footerPage := (PRPage named: 'footer')
		contents:
'{{{<div class="footer column span-24 last">
	<div class="column span-18">
		}}}+/system/components/justlogincommand+
		+/system/components/loggedinuser+{{{
		<div class="commands">}}}+/system/components/commands+{{{</div>
		<div class="views">}}}+/system/components/views+{{{</div>
		<div class="sitemap">}}}+/system/components/sitemap+{{{</div>
	</div>
	<div class="column span-6 last">}}}+/system/components/poweredby+{{{</div>
</div>}}}';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:27'!
googleAnalyticsWidget
	^ googleAnalyticsWidget ifNil: [ 
		googleAnalyticsWidget := (PRComponent named: 'googleanalytics')
		title: 'Google Analytics';
		componentClass: PRGoogleAnalyticsWidget
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/2/2010 17:52'!
headerPage
	^ headerPage ifNil: [
		headerPage := (PRPage named: 'header')
		contents:
'{{{<div class="column span-24 last header">
	<div class="menu">}}}+/system/components/menu|menu+{{{</div>
</div>}}}';
		yourself
	]! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/6/2008 18:46'!
kernel
	^ kernel ifNil: [
		kernel := PRKernel named: 'pier'.
		kernel root: self root.
		kernel
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
loggedInUserPage
	^ loggedInUserPage ifNil: [
		loggedInUserPage := (PRPage named: 'loggedinuser') 
		addChild: ((PRComponent named: 'widget') componentClass: PUSecurityWidget; yourself);
		contents: 'Logged in as *value:user* (+widget+?)';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/8/2008 15:58'!
loginCommandWidget
	^ loginCommandWidget ifNil: [
		loginCommandWidget := (PRComponent named: 'justlogincommand')
		title: 'Just Login Command';
		componentClass: PRCommandsWidget;
		write: (Array with: PULogin) using: PRCommandsWidget descriptionCommandClasses ;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
mainEnvironmentPage
	^ mainEnvironmentPage ifNil: [
		mainEnvironmentPage := (PRPage named: 'mainenvironment')
		title: '_Main Environment';
		contents: 
'{{{<div class="container">
	}}}+/system/components/header+{{{
	<div class="column span-24 last mainbody">
		<h1 class="heading">}}}*value:structure*{{{</h1>
		<div class="contents column span-12">}}}+/system/components/contents+{{{</div>
		<div class="postticker column prepend-6 span-6 last">
			<h2>What''s new</h2>
			}}}+/system/components/postticker+
			+/system/components/sidebar+{{{
		</div>
	</div>
	}}}+/system/components/footer+{{{
</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:52'!
makePrivate: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:59'!
makePublic: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 4/4/2009 15:58'!
menuPage
	^ menuWidget ifNil: 
		[ menuWidget := (PRPage named: 'menu')
			contents:
'- *Home>/*
- *Blog>/blog*
- *About>/about*';
			yourself ]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/2/2010 17:50'!
metaEnvironmentPage
	^ metaEnvironmentPage ifNil: [
		metaEnvironmentPage := (PRPage named: 'metaenvironment')
		title: '_Meta Environment';
"		hideFromMenus: true;"
		contents: '{{{<div class="container metaenvironment">
	<div class="span-24 last metaheader">
		Meta page: }}}+/system/components/breadcrumb+{{{
	</div>
	<div class="span-24 last">
		}}}+/system/components/contents+{{{
	</div>
	<div class="span-24 last metafooter">
		<div class="span-10">}}}+/system/components/commands+{{{</div>
		<div class="span-10 last">}}}+/system/components/sitemap+{{{</div>
	</div>
</div>}}}';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:30'!
postTickerWidget
	^ postTickerWidget ifNil: [
		postTickerWidget := (PRComponent named: 'postticker')
		title: 'Post Ticker';
		componentClass: PBPostTicker;
		write: blog using: PBPostTicker descriptionBlog;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 14:42'!
poweredPage
	^ poweredByPage ifNil: [poweredByPage := (PRPage named: 'poweredby')
		title: 'Powered By';
		contents: 
'Powered by *Pier>http://www.piercms.com*';
		yourself
	]! !

!PRDistribution methodsFor: 'creation' stamp: 'lr 7/26/2010 19:04'!
register 
	PRKernel reset.
	PRPierFrame 
		registerAsApplication: 'pier'
		kernel: self kernel! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 2/19/2009 00:17'!
replaceRoot
	kernel := PRKernel instances anyOne.
	kernel root: self root! !

!PRDistribution methodsFor: 'creation' stamp: 'MaartenDaalder 7/3/2011 15:07'!
root
	self rootPage
		addChild: self blog;
		addChild: (self aboutPage
				addChild: self syntaxPage;
				yourself);
		addChild: (self systemPage
			addChild: (self componentsPage
				addChild: self headerPage;
				addChild: self siteTitlePage;
				addChild: self footerPage;
				addChild: self menuPage;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self postTickerWidget;
				addChild: self blogArchiveWidget;
				addChild: self searchWidget;
				addChild: self poweredPage;
				addChild: self loggedInUserPage;
				addChild: self designChooserWidget;
				addChild: self documentWidget;
				yourself);
			addChild: self systemManagementPage;
			addChild: (self templatesPage
				addChild: self environmentPage;
				addChild: self blogEnvironmentPage;
				addChild: self mainEnvironmentPage;
				addChild: self metaEnvironmentPage;
				yourself
			);
			yourself
		).
	self rootPage localEnvironment: self mainEnvironmentPage.
	self blog localEnvironment: self blogEnvironmentPage.
	self aboutPage localEnvironment: self environmentPage.
	self environmentPage localEnvironment: self metaEnvironmentPage.
	self mainEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self systemManagementPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	self rootPage enumerator
		with;
		all;
		do: 
			[ :each | 
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self systemPage.
	self makePrivate: self environmentPage.
	self makePrivate: self blogEnvironmentPage.
	self makePrivate: self mainEnvironmentPage.
	self makePrivate: self metaEnvironmentPage.
"	self makePublic: self sitemapPage." "Disabled because makePublic has the same implementation as makePrivate, added issue 134 on the public issue tracker for this."
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	self makePrivate: self loggedInUserPage.	
	"pier-sprint-eindhoven -http://forum.world.st/huge-security-problem-with-pier-td3241518.html".	
	self makePrivate: self designChooserWidget.
	^ self rootPage! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/2/2010 17:53'!
rootPage
	^ rootPage ifNil: [
		rootPage := (PRPage named: 'pier')
		title: 'Welcome to Pier!!';
		yourself.

		rootPage 
		contents:
'This is the main page of the official Pier distribution. Before you can modify this site, you have to login using: admin/pier.

If you are not satisfied with the current look, perhaps you want to choose another one:

+/system/components/designchooser+

Have fun!!

The Pier Team
'.
		rootPage]! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 10/7/2010 16:10'!
searchWidget
	^ searchWidget ifNil: [
		searchWidget := (PRComponent named: 'search')
			componentClass: PRSearchWidget;
			write: ( PRStructure withAllConcreteClasses reject: [:each | each = PRPage or: [each = PBPost]] ) using: PRAjaxSearchWidget descriptionFilter ;
			yourself
	].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:11'!
siteTitlePage
	^ siteTitlePage ifNil: [
		siteTitlePage := (PRPage named: 'sitetitle')
		title: 'Site Title';
		contents: '!!*Your Pier>/*';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'MaartenDaalder 7/3/2011 14:54'!
sitemapPage
	sitemapPage
		ifNil: [ 
			(sitemapPage := PRPage named: 'sitemap')
				addChild:
						((PRComponent named: 'widget')
								componentClass: PRTreeWidget;
								yourself);
				contents:
						'Sitemap
+widget+'.
			sitemapPage securityDecoration otherPermissions: PRViewCommand permissions ].
	^ sitemapPage! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 7/10/2009 15:59'!
stylesheetFile
	^ stylesheetFile ifNil: [
		stylesheetFile := (PRFile named: 'defaultCss')
		filename: 'style.css';
		mimetype: 'text/css';
		contents: 
'/* HEADER */
.icon a {outline: none; background: white;}
.search input.text {
	border: 1px solid white;
	color: black;}
.search input.text:focus {
	border: 1px solid #ff6633;
	color: black;}
.search input {
	color: #ff6633;
	font-size: 1em;
	outline: none;
	width: 98%;
	border: 0;
	margin-top: 0.1em;
	padding: 0.3em;
	padding-top: 0;
	background: 0;}
.search ul {
	margin: 0;
	padding: 0;
	background: white;
	list-style-type: none;
	border: 1px solid #ff6633;
	border-top: 0;}
.search li.selected a {color: #fff;}
.search li.selected {
	background-color: #ff6633;
	color: white;}
.search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;}
.menu ul {
	margin: 0;
	margin-top: 0.2em;
	padding-bottom: 0.2em;
	list-style-type: none;}
.menu ul li {
	display: inline;
	margin: 0;
	margin-right: 1.5em;
	list-style-type: none;}
.menu li a {
	padding-left: 0.3em;
	padding-right: 0.3em;
	padding-top: 0.5em;
	padding-bottom: 0.3em;}


/*BLOG*/
div.post {margin-bottom: 4.5em;}
div.comment {margin-bottom: 3em;}
.meta {font-size: 80%; color: #aaa;}
.leavecomment {margin-top: 4.5em; margin-bottom: 4.5em;}
.comments {margin-top: 4.5em;}


/* NAVIGATION */
.sidebar ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.sidebar ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.sidebar ul li {
	margin-top: 1.5em;}
.sidebar ul li a {
	padding-left: 0.3em;
	padding-right: 0.3em;
	padding-top: 0.3em;
	padding-bottom: 0.3em;}
.sidebar p,
.sidebar h1, .sidebar h2, .sidebar h3,
.sidebar .postticker .timestamp,
.sidebar .postticker .summary {padding-left: 0.3em;}
.sidebar .active,
.menu li a.active {
	color: white;
	background: #ff6633;}


/*MAIN BODY*/
.mainbody {
	padding-top: 4em;
	padding-bottom: 15em;}
.postticker ul {
	font-size: 80%;
	color: #aaa;
	list-style: none;
	margin-left: 0;}
.postticker ul li {
	margin-bottom: 1.5em;}
.postticker .timestamp {color: #aaa; font-size: 80%;}
.postticker .subscribe,
.postticker .timestamp .time,
.postticker .timestamp .author {display: none;}
.postticker a.post {color: #aaa;}


/* FOOTER */
.footer {
	color: #aaa;
	font-size: 80%;
	text-align: left;}
.footer a { color: #aaa;}
.footer ul {list-style: none; margin-left: 0em;}
.footer ul ul {margin-left: 1.5em;}
.footer .commands ul, .footer .views ul {display: inline;}
.footer .commands ul li, .footer .views ul li {display: inline; padding-right: 1em;}


/* META */
.metaenvironment h1.heading {display: none;}
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}


/*DEFAULT*/
body {margin-top: 0;}
h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: inherit; }
h1.heading { font-size: 2em; margin-bottom: 1.5em; }
h1 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
.maincontents {font-size: 1.5em;}
h2 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h3 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h4 { font-size: 1em; font-weight: bold; }
h5 { font-size: 1em; }
textarea {width: 100%;}
input.text, input.password {width: 200px;}
input[type="button"], input[type="submit"], input[type="reset"], input[type="file"], button { margin-left: 0.5em;} 


/* PIER */
.broken { color: red; font-weight: bold;}
.protected { color: #aaa; }
a {color: #ff6633;}
a:hover {
	color: white;
	background: #ff6633; }
a:hover.nobackground {background: white;}
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}
.right {text-align: right;}
.left {text-align: left;}
.center {text-align: center;}
.float {float: right;}
.nobullets ul {list-style: none; margin-left: 0;}
.nobullets ul li {list-style: none; margin-left: 0;}
tr th {background: #eee; font-weight: normal;}
label {font-weight: normal;}
tr.group th {background: white; font-size: 1em; font-weight: bold; margin-top: 1.5em; }
td.required:after {color: #ff6633; content: "*"; margin-left: 0.5em;}
';
		yourself]! !

!PRDistribution methodsFor: 'structures' stamp: 'damiencassou 1/21/2009 18:48'!
syntaxPage
	^ syntaxPage ifNil: [
		syntaxPage := PRKernel defaultInfoSyntax].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 12/7/2009 14:04'!
systemManagementPage
	^ systemManagementPage ifNil: [
		systemManagementPage := (PRPage named: 'management')
		title: 'Management';
		addChild: ((PRComponent named: 'users')
				componentClass: PUUsersWidget;
				yourself);
		addChild: ((PRComponent named: 'groups')
				componentClass: PUGroupsWidget;
				yourself);
		addChild: ((PRComponent named: 'persistency')
				componentClass: PRPersistencySettings;
				yourself);
		addChild: ((PRComponent named: 'kernel')
				componentClass: PRKernelSettings;
				yourself);
		addChild: ((PRComponent named: 'file')
				componentClass: PRFileSettings;
				yourself);
		contents: '!!Users
+users+

!!User Group
+groups+

!!Persistency
+persistency+

!!Kernel Settings
+kernel+

!!File Settings
+file+';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
systemPage
	^ systemPage ifNil: [
		systemPage := (PRPage named: 'system')
		contents: '*value:children|link*';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
templatesPage
	^ templatesPage ifNil: [
		templatesPage := (PRPage named: 'templates')
		contents: '*value:children|link*';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:33'!
viewsPage
	^ viewsPage ifNil: [
		viewsPage := (PRPage named: 'views')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRViewsWidget;
				yourself);
		contents: 'Views: +widget+'
	]! !

PRDistribution subclass: #PREventDistribution
	instanceVariableNames: 'eventTitlePage callPage pcPage datesPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PREventDistribution class methodsFor: 'accessing' stamp: 'tg 2/18/2009 23:30'!
title
	^ 'Event'! !

!PREventDistribution methodsFor: 'structures' stamp: 'tg 2/22/2009 22:23'!
blog
	^ blog ifNil: [
		blog := (PBBlog named: 'news')
		addChild: (
			(PBPost named: 'online')
			title: 'Online';
			contents: 'The page is online. Stay tuned for more news.';
			publication: TimeStamp today;
			yourself
		);
		yourself
	].
! !

!PREventDistribution methodsFor: 'structures' stamp: 'tg 2/19/2009 00:45'!
callPage
	^ callPage ifNil: 
		[ callPage := (PRPage named: 'call')
			title: 'Call for Contributions';
			contents: 'TBA';
			yourself ]! !

!PREventDistribution methodsFor: 'structures' stamp: 'tg 2/19/2009 01:01'!
datesPage
	^ datesPage ifNil: 
		[ datesPage := (PRPage named: 'dates')
			title: 'Important Dates';
			contents: 'TBA';
			yourself ]! !

!PREventDistribution methodsFor: 'structures' stamp: 'lr 10/9/2010 11:14'!
environmentPage
	^ environmentPage ifNil: [
		environmentPage := (PRPage named: 'environment')
		title: '_Environment';
		contents: 
'{{{<div class="header">
	<div class="container">
		<div class="eventTitle">}}}+/system/components/eventtitle+{{{</div>
		<div class="menu">}}}+/system/components/menu|menu+{{{</div>
	</div>
</div>
<div class="container">
	<div class="column span-24 last mainbody">
		<h1>}}}*value:structure*{{{</h1>
		<div class="column span-12 contents">
			}}}+/system/components/contents+{{{
		</div>
		<div class="column span-6 prepend-6 last sidebar">
			<h2>What''s new</h2>
			<div class="postticker">}}}+/system/components/postticker+{{{</div>
		</div>
	</div>
	}}}+/system/components/footer+{{{
</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]! !

!PREventDistribution methodsFor: 'structures' stamp: 'tg 2/2/2010 17:57'!
eventTitlePage
	^ eventTitlePage ifNil: 
		[ eventTitlePage := (PRPage named: 'eventtitle')
			title: 'Event Title';
			contents: '{{{<h1 class="heading">Event</h1>
			<h2>Location</h2>}}}';
			yourself ]! !

!PREventDistribution methodsFor: 'structures' stamp: 'tg 4/4/2009 16:04'!
menuPage
	^ menuWidget ifNil: 
		[ menuWidget := (PRPage named: 'menu')
			contents:
'- *Home>/*
- */call*
- */pc*
- */dates*
- */news*';
			yourself ]! !

!PREventDistribution methodsFor: 'structures' stamp: 'tg 2/19/2009 00:45'!
pcPage
	^ pcPage ifNil: 
		[ pcPage := (PRPage named: 'pc')
			title: 'Program Committee';
			contents: 'TBA';
			yourself ]! !

!PREventDistribution methodsFor: 'creation' stamp: 'razaviacmorg 7/3/2011 11:04'!
root
	self rootPage
		addChild: self blog;
		addChild: self pcPage;
		addChild: self callPage;
		addChild: self datesPage;
		addChild: (self systemPage
			addChild: (self componentsPage
				addChild: self headerPage;
				addChild: self siteTitlePage;
				addChild: self footerPage;
				addChild: self menuPage;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self postTickerWidget;
				addChild: self blogArchiveWidget;
				addChild: self searchWidget;
				addChild: self poweredPage;
				addChild: self loggedInUserPage;
				addChild: self designChooserWidget;
				addChild: self eventTitlePage;
"				addChild: self documentWidget;
"				yourself);
			addChild: self systemManagementPage;
			addChild: (self templatesPage
				addChild: self environmentPage;
				"addChild: self blogEnvironmentPage;"
				"addChild: self mainEnvironmentPage;"
				addChild: self metaEnvironmentPage;
				yourself
			);
			yourself
		).
	self rootPage localEnvironment: self environmentPage"mainEnvironmentPage".
	"self blog localEnvironment: self blogEnvironmentPage."
	self environmentPage localEnvironment: self metaEnvironmentPage.
	"self mainEnvironmentPage localEnvironment: self metaEnvironmentPage."
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self systemManagementPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	
	self rootPage enumerator
		with;
		all;
		do: 
			[ :each | 
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self systemPage.
	self makePrivate: self environmentPage.
	"self makePrivate: self blogEnvironmentPage."
	"self makePrivate: self mainEnvironmentPage."
	self makePrivate: self metaEnvironmentPage.
	self makePrivate: self sitemapPage.
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	self makePrivate: self loggedInUserPage.
	"pier-sprint-eindhoven -http://forum.world.st/huge-security-problem-with-pier-td3241518.html".	
	self makePrivate: self designChooserWidget.
	^ self rootPage
! !

!PREventDistribution methodsFor: 'structures' stamp: 'tg 4/4/2009 16:44'!
stylesheetFile

	^ stylesheetFile ifNil: [
		stylesheetFile := (PRFile named: 'eventCss')
		filename: 'style.css';
		mimetype: 'text/css';
		contents: 
'.header h1.heading { font-size: 2em; padding-top: 1.5em; margin-bottom: 0; color: white;}
.header h2 { font-size: 1.2em; margin-top: 0; padding-bottom: 1.25em; color: white;}
.header {background: #545454; color: white;}
body {font-size: 11pt;}


/* HEADER */
.menu ul {
	margin: 0;
	margin-top: 0.2em;
	list-style-type: none;}
.menu ul li {
	display: inline;
	margin: 0;
	margin-right: 1.5em;
	list-style-type: none;}
.menu li a {
	padding-left: 1em;
	padding-right: 1em;
	padding-top: 0.5em;
	padding-bottom: 1em;}


/*BLOG*/
div.post {margin-bottom: 4.5em;}
div.comment {margin-bottom: 3em;}
.meta {font-size: 80%; color: #aaa;}
.leavecomment {margin-top: 4.5em; margin-bottom: 4.5em;}
.comments {margin-top: 4.5em;}


/* NAVIGATION */
.sidebar ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.sidebar ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.sidebar ul li {
	margin-top: 1.5em;}
.sidebar ul li a {
/*	padding-left: 0.3em;
	padding-right: 0.3em;
*/	padding-top: 0.3em;
	padding-bottom: 0.3em;}
.sidebar p,
.sidebar h1, .sidebar h2, .sidebar h3,
.sidebar .postticker .timestamp,
.sidebar .postticker .summary {}
.sidebar .active,
.menu li a.active {
	color: white;
	background: #ff6633;}


/*MAIN BODY*/
.mainbody {
	padding-top: 4em;
	padding-bottom: 15em;}
.postticker ul {
	list-style: none;
	margin-left: 0;}
.postticker ul li {
	margin-bottom: 1.5em;}
.postticker .timestamp {display: inline; padding-left: 1em; color: #aaa; font-size: 80%;}
.postticker .subscribe,
.postticker .timestamp .time,
.postticker .timestamp .author {display: none;}


/* FOOTER */
.footer {
	color: #aaa;
	font-size: 80%;
	text-align: left;}
.footer a { color: #aaa;}
.footer ul {list-style: none; margin-left: 0em;}
.footer ul ul {margin-left: 1.5em;}
.footer .commands ul, .footer .views ul {display: inline;}
.footer .commands ul li, .footer .views ul li {display: inline; padding-right: 1em;}


/* META */
.metaenvironment h1.heading {display: none;}
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}


/*DEFAULT*/
body {margin-top: 0;}
h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: inherit; }
h1 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
.maincontents {font-size: 1.5em;}
h2 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h3 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h4 { font-size: 1em; font-weight: bold; }
h5 { font-size: 1em; }
textarea {width: 100%;}


/* PIER */
.broken { color: red; font-weight: bold;}
.protected { color: #aaa; }
a {color: #ff6633;}
a:hover {
	color: white;
	background: #ff6633; }
a:hover.nobackground {background: white;}
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}
.right {text-align: right;}
.left {text-align: left;}
.center {text-align: center;}
.float {float: right;}
.nobullets ul {list-style: none; margin-left: 0;}
.nobullets ul li {list-style: none; margin-left: 0;}
th {background: #eee; font-weight: normal;}';
		yourself
	]! !

PRWidget subclass: #PRDesignChooserWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PRDesignChooserWidget class methodsFor: 'testing' stamp: 'tg 2/18/2009 23:38'!
isAbstract
	^false! !

!PRDesignChooserWidget methodsFor: 'rendering' stamp: 'Nick 6/13/2010 17:49'!
renderContentOn: html

	html unorderedList with: [
		PRDistribution withAllSubclasses do: [:each |
			html listItem with: [
				html anchor callback: [
					(self confirm: 'You will replace the entire content and design of the current Pier. Do you want to continue?')
						ifTrue: [
							PRKernel reset.
							WACurrentRequestContext value application preferenceAt: #kernel put: each new kernel.
							self session unregister.
							self requestContext redirectTo: self application  url ]
				]; with: each title
			]
		]
	]! !
